package ru.dbotthepony.mc.prng;

import net.minecraft.util.RandomSource;
import net.neoforged.fml.ModList;
import net.neoforged.fml.common.Mod;

import java.util.function.Supplier;

@Mod(BetterRandom.MOD_ID)
public final class BetterRandom {
	public static final String MOD_ID = "better_random";
	public static final String SAVEDATA_LOCATION = "better_random_sequences";

	private static RandomSource createWorldRandomC2ME(Supplier<Thread> thread) {
		// TODO: actually implement proper integration
		//  also, this shouldn't be synchronized, per say, in this way, but instead throw an exception when
		//  concurrently accessed (to match C2ME and vanilla behavior)
		return new SynchronizedGJRAND64RandomSource();
	}

	public static RandomSource createWorldRandom(Supplier<Thread> thread) {
		if (ModList.get().isLoaded("c2me"))
			return createWorldRandomC2ME(thread);

		return new GJRAND64RandomSource();
	}
}
